# Install file for GCDkit  6.2.0  patch no 240226 
# The patch may be installed by:
#   * copying the install file into directory GCDkit/Patch 
#   * drag & drop of this install file into the R Console 
#   * manual pasting of the install file content into the R Console (ctrl-C, ctrl-V)

patchID<-"240226"
if (file.access(paste(gcdx.dir,"/Patch/patch",patchID,".r",sep=""), mode = 4)==-1){
cat ("Installing the file patch",patchID,".r\n",sep="")
patch<-c( 
"# GCDkit  6.2.0  patch no 240226 ", 
"",
"# updated function r2clipboard()",
"r2clipboard<-","function (what = results) " ,
"{" ,
"    on.exit(options(show.error.messages = TRUE))" ,
"    if (is.null(what)) {" ,
"        winDialog(type = \"ok\", \"No data available\")" ,
"        options(show.error.messages = FALSE)" ,
"        stop(\" \", call. = FALSE)" ,
"    }" ,
"    sys.type <- Sys.info()[\"sysname\"]" ,
"    ee <- switch(sys.type, Darwin = {" ,
"        filename <- pipe(\"pbcopy\")" ,
"    }, Windows = {" ,
"        filename <- file(\"clipboard\", open = \"w\")" ,
"    }, filename <- pipe(\"xclip -i -sel p -f | xclip -i -sel c\", " ,
"        \"w\"))" ,
"    cat(\"Please wait....\")" ,
"    flush.console()" ,
"    if (is.list(what) & package.name == \"GCDkit.Mineral\" & length(what) == " ,
"        1) " ,
"        what <- t(what[[1]])" ,
"    if (is.vector(what)) {" ,
"        what <- as.matrix(what)" ,
"        colnames(what) <- NULL" ,
"    }" ,
"    if (is.table(what)) {" ,
"        if (length(attributes(results)$dim) != 2) {" ,
"            write.ftable(ftable(what), file = filename, quote = TRUE, " ,
"                digits = getOption(\"gcd.digits\"))" ,
"            cat(\"done\\n\")" ,
"            flush.console()" ,
"            return()" ,
"        }" ,
"        else {" ,
"            what <- as.matrix(what)" ,
"        }" ,
"    }" ,
"    if (is.list(what) & !is.data.frame(what)) {" ,
"        lapply(1:length(what), function(i) {" ,
"            x <- data.frame(what[[i]], check.names = FALSE)" ,
"            if (is.vector(what[[i]])) {" ,
"                x <- c(dimnames(what)[[1]][i], x)" ,
"            }" ,
"            else {" ,
"                if (nrow(x) == 1) {" ,
"                  x <- cbind(c(\"\", dimnames(what)[[1]][i]), rbind(colnames(x), " ,
"                    x))" ,
"                }" ,
"                else {" ,
"                  colnames(x)[1] <- dimnames(what)[[1]][i]" ,
"                }" ,
"            }" ,
"            cat(\".\")" ,
"            flush.console()" ,
"            write.table(x, file = filename, sep = \"\\t\", col.names = TRUE, " ,
"                row.names = FALSE)" ,
"            write(\"\", file = filename, append = TRUE)" ,
"        })" ,
"    }" ,
"    else {" ,
"        x <- cbind(rownames(what), what)" ,
"        x <- rbind(c(\"Sample\", colnames(what)), x)" ,
"        if (sys.type == \"Windows\") {" ,
"            write.table(x, file = filename, col.names = FALSE, " ,
"                row.names = FALSE, quote = FALSE, sep = \"\\t\", " ,
"                eol = \"\\n\")" ,
"        }" ,
"        else {" ,
"            write.table(x, file = filename, col.names = FALSE, " ,
"                row.names = FALSE, quote = FALSE, sep = \"\\t\", " ,
"                eol = \"\\r\")" ,
"        }" ,
"    }" ,
"    if (.Platform$GUI != \"AQUA\") " ,
"        close(filename)" ,
"    cat(\"done.\\n\")" ,
"    flush.console()" ,
"    invisible()" ,
"}" ,
"",
"# updated function saveResults()",
"saveResults<-","function (what = results, sep = \"\\t\", digits = 2) " ,
"{" ,
"    on.exit(options(show.error.messages = TRUE))" ,
"    if (is.null(what)) {" ,
"        winDialog(type = \"ok\", \"No data available\")" ,
"        options(show.error.messages = FALSE)" ,
"        stop(\" \", call. = FALSE)" ,
"    }" ,
"    val <- tkgetSaveFile(initialdir = getwd(), initialfile = \"\", " ,
"        title = \"Saving results to text file...\", defaultextension = \".txt\", " ,
"        confirmoverwrite = TRUE, filetypes = \"{\\n            {Text files}\\n            {*.txt *.TXT}\\n        }\")" ,
"    filename <- tclvalue(val)" ,
"    options(show.error.messages = FALSE)" ,
"    if (filename == \"\") {" ,
"        cat(\"Cancelled.\\n\")" ,
"        stop(\" \", call. = FALSE)" ,
"    }" ,
"    options(show.error.messages = TRUE)" ,
"    options(show.error.messages = TRUE)" ,
"    if (is.table(what)) {" ,
"        if (length(attributes(results)$dim) != 2) {" ,
"            ee <- write.ftable(ftable(what), file = filename, " ,
"                quote = TRUE, digits = digits)" ,
"            winDialog(\"ok\", \"File saved successfully\")" ,
"            return()" ,
"        }" ,
"        else {" ,
"            what <- as.matrix(what)" ,
"        }" ,
"    }" ,
"    if (is.list(what) & !is.data.frame(what)) {" ,
"        for (i in 1:length(what)) {" ,
"            ee <- write.table(t(c(names(what)[i], colnames(what[[i]]))), " ,
"                row.names = FALSE, filename, sep = \"\\t\", quote = FALSE, " ,
"                col.names = FALSE, na = \"\", append = TRUE)" ,
"            ee <- write.table(data.frame(what[i]), filename, " ,
"                sep = \"\\t\", quote = FALSE, col.names = FALSE, " ,
"                na = \"\", append = TRUE)" ,
"        }" ,
"        winDialog(\"ok\", \"File saved successfully\")" ,
"        return()" ,
"    }" ,
"    if (is.data.frame(what)) {" ,
"        ee <- write.table(what, file = filename, quote = FALSE, " ,
"            sep = \"\\t\")" ,
"    }" ,
"    if (is.matrix(what)) {" ,
"        ee <- MASS::write.matrix(cbind(rownames(what), round(what, " ,
"            digits)), file = filename, sep = sep)" ,
"    }" ,
"    winDialog(\"ok\", \"File saved successfully\")" ,
"    invisible()" ,
"}" ,
"",
"# updated function sampleDataset()",
"sampleDataset<-","function (mineral = NULL) " ,
"{" ,
"    options(show.error.messages = TRUE)" ,
"    if (is.null(mineral)) {" ,
"        dir <- paste(gcdx.dir, \"data\", sep = \"/\")" ,
"        ee <- list.files(dir, \"*.csv\", full.names = FALSE)" ,
"        if (length(ee) == 0) {" ,
"            cat(\"No relevant data found.\\n\")" ,
"            options(show.error.messages = FALSE)" ,
"            stop(\" \", call. = FALSE)" ,
"        }" ,
"        eee <- unlist(strsplit(ee, \"[.]\"))" ,
"        eee <- eee[eee != \"csv\" & eee != \"gz\"]" ,
"        mineral <- utils::select.list(eee, title = \"Select sample dataset\", " ,
"            preselect = eee[1])" ,
"        if (mineral == \"\") {" ,
"            cat(\"Cancelled.\\n\")" ,
"            options(show.error.messages = FALSE)" ,
"            stop(\" \", call. = FALSE)" ,
"        }" ,
"    }" ,
"    mineral <- tools::file_path_sans_ext(basename(mineral))" ,
"    filoun <- paste(gcdx.dir, \"/data/\", mineral, \".csv\", sep = \"\")" ,
"    eval(parse(text = paste(mineral, \"<<-read.table('\", filoun, " ,
"        \"',header=TRUE,as.is=TRUE,check.names = FALSE,sep=\\\";\\\")\", " ,
"        sep = \"\")))" ,
"    accessVar(mineral)" ,
"    rm(mineral, envir = .GlobalEnv)" ,
"    ee <- paste(\"sampleDataset(\\\"\", mineral, \"\\\")\", sep = \"\")" ,
"    .save2hist(ee)" ,
"    invisible()" ,
"}" ,
"",
"# updated function .annotate.main()",
".annotate.main<-","function (a) " ,
"{" ,
"    on.exit(options(show.error.messages = TRUE))" ,
"    if (substring(a, 1, 10) == \"87Sr/86Sri\") " ,
"        return(srlab)" ,
"    if (substring(a, 1, 12) == \"143Nd/144Ndi\") " ,
"        return(ndlab)" ,
"    if (substring(a, 1, 11) == \"176Hf/177Hf\") " ,
"        return(hflab)" ,
"    if (substring(a, 1, 6) == \"EpsNdi\") " ,
"        return(epsNdlabi)" ,
"    if (substring(a, 1, 6) == \"EpsHfi\") " ,
"        return(epsHflabi)" ,
"    if (substring(a, 1, 8) == \"TDM.2stg\") " ,
"        return(expression(T[DM.2stg]^Nd))" ,
"    if (substring(a, 1, 3) == \"TDM\") " ,
"        return(expression(T[DM]^Nd))" ,
"    if (substring(a, 1, 10) == \"HfTDM.2stg\") " ,
"        return(expression(T[DM.2stg]^Hf))" ,
"    if (substring(a, 1, 10) == \"HfTDM.1stg\") " ,
"        return(expression(T[DM]^Hf))" ,
"    if (substring(a, 1, 12) == \"HfTCHUR.1stg\") " ,
"        return(expression(T[CHUR]^Hf))" ,
"    if (substring(a, 1, 12) == \"206Pb/204Pbi\") " ,
"        return(expression(\" \"^206 * Pb/\" \"^204 * Pb[i]))" ,
"    if (substring(a, 1, 12) == \"207Pb/204Pbi\") " ,
"        return(expression(\" \"^207 * Pb/\" \"^204 * Pb[i]))" ,
"    if (substring(a, 1, 12) == \"208Pb/204Pbi\") " ,
"        return(expression(\" \"^208 * Pb/\" \"^204 * Pb[i]))" ,
"    if (substring(a, 1, 12) == \"208Pb/206Pbi\") " ,
"        return(expression(\" \"^208 * Pb/\" \"^206 * Pb[i]))" ,
"    if (substring(a, 1, 11) == \"147Sm/144Nd\") " ,
"        return(expression(\" \"^147 * Sm/\" \"^144 * Nd))" ,
"    if (substring(a, 1, 11) == \"143Nd/144Nd\") " ,
"        return(expression(\" \"^143 * Nd/\" \"^144 * Nd))" ,
"    if (substring(a, 1, 11) == \"176Lu/177Hf\") " ,
"        return(expression(\" \"^176 * Lu/\" \"^177 * Hf))" ,
"    if (substring(a, 1, 11) == \"176Hf/177Hf\") " ,
"        return(expression(\" \"^176 * Hf/\" \"^177 * Hf))" ,
"    if (substring(a, 1, 9) == \"87Rb/86Sr\") " ,
"        return(expression(\" \"^87 * Rb/\" \"^86 * Sr))" ,
"    if (substring(a, 1, 9) == \"87Sr/86Sr\") " ,
"        return(expression(\" \"^87 * Sr/\" \"^86 * Sr))" ,
"    if (substring(a, 1, 11) == \"206Pb/204Pb\") " ,
"        return(expression(\" \"^206 * Pb/\" \"^204 * Pb))" ,
"    if (substring(a, 1, 11) == \"207Pb/204Pb\") " ,
"        return(expression(\" \"^207 * Pb/\" \"^204 * Pb))" ,
"    if (substring(a, 1, 11) == \"208Pb/204Pb\") " ,
"        return(expression(\" \"^208 * Pb/\" \"^204 * Pb))" ,
"    if (substring(a, 1, 11) == \"207Pb/206Pb\") " ,
"        return(expression(\" \"^207 * Pb/\" \"^206 * Pb))" ,
"    if (substring(a, 1, 11) == \"208Pb/206Pb\") " ,
"        return(expression(\" \"^208 * Pb/\" \"^206 * Pb))" ,
"    if (substring(a, 1, 10) == \"206Pb/238U\") " ,
"        return(expression(\" \"^206 * Pb/\" \"^238 * U))" ,
"    if (substring(a, 1, 10) == \"207Pb/235U\") " ,
"        return(expression(\" \"^207 * Pb/\" \"^235 * U))" ,
"    if (substring(a, 1, 11) == \"208Pb/232Th\") " ,
"        return(expression(\" \"^208 * Pb/\" \"^232 * Th))" ,
"    a <- gsub(\"%\", \"*symbol(\\\"\\\\\\\\045\\\")\", a)" ,
"    if (substring(a, 1, 18) == \"TZr.sat.C(Boehnke)\") " ,
"        return(expression(\"Zircon saturation T (Boehnke et al. 2013) (C)\"))" ,
"    if (substring(a, 1, 9) == \"TZr.sat.C\") " ,
"        return(expression(\"Zircon saturation T (Watson and Harrison 1983) (C)\"))" ,
"    if (substring(a, 1, 9) == \"Tmz.sat.C\") " ,
"        return(expression(\"Monazite saturation T (C)\"))" ,
"    if (substring(a, 1, 13) == \"Tap.sat.C.H&W\") " ,
"        return(expression(\"Apatite saturation T (Harrison & Watson 1984) (C)\"))" ,
"    if (substring(a, 1, 14) == \"Tap.sat.C.Pich\") " ,
"        return(expression(\"Apatite saturation T (Pichavant et al. 1992) (C)\"))" ,
"    if (substring(a, 1, 13) == \"Tap.sat.C.Bea\") " ,
"        return(expression(\"Apatite saturation T (Bea et al. 1992) (C)\"))" ,
"    a <- gsub(\"(delta)([0-9]{1,})([A-Z][a-z]?)\", \"delta^\\\\2\\\\3\", " ,
"        a)" ,
"    a <- gsub(\"([A-Z])([a-z]?)N/([A-Z])([a-z]?)N\", \"\\\\1\\\\2[N]/\\\\3\\\\4[N]\", " ,
"        a)" ,
"    a <- gsub(\"Sum_REE\", \"Sigma*REE\", a)" ,
"    a <- gsub(\" \", \"~\", a)" ,
"    a <- gsub(\"#\", \"\", a)" ,
"    a <- gsub(\"([.])([0-9]{1,}$)\", \"(\\\\2\\\\3)\", a)" ,
"    a <- gsub(\"[.]OR[.]\", \"~or~\", a)" ,
"    a <- gsub(\"[.]AND[.]\", \"~and~\", a)" ,
"    a <- gsub(\"([|])\", \"~or~\", a)" ,
"    a <- gsub(\" & \", \"~and~\", a)" ,
"    a <- gsub(\"&\", \"~and~\", a)" ,
"    a <- gsub(\"([0-9a-zA-Z()]])([=])\", \"\\\\1==\", a)" ,
"    a <- gsub(\"([0-9][*][0-9])\", \"@\", a)" ,
"    a <- gsub(\"([a-zA-Z])([0-9])\", \"\\\\1[\\\\2\", a)" ,
"    a <- gsub(\"([[])([0-9])([-a-zA-Z@+(~])\", \"\\\\1\\\\2]*\\\\3\", a)" ,
"    a <- gsub(\"([[])([0-9])([,)])\", \"\\\\1\\\\2]\\\\3\", a)" ,
"    a <- gsub(\"([[])([0-9])([<>=])\", \"\\\\1\\\\2]\\\\3\", a)" ,
"    a <- gsub(\"([0-9])([a-zA-Z$])\", \"\\\\1*\\\\2\\\\\", a)" ,
"    a <- gsub(\"([[])([0-9])([)/])\", \"\\\\1\\\\2]\\\\3\", a)" ,
"    a <- gsub(\"[*][@]\", \"@\", a)" ,
"    a <- gsub(\"([@])\", \"\\\\%*\\\\%\", a)" ,
"    a <- gsub(\"[*][*]\", \"*\", a)" ,
"    a <- gsub(\"([0-9])([0-9])([0-9])([a-zA-Z])\", \"\\\" \\\"^\\\\1\\\\2\\\\3*\\\\4\", " ,
"        a)" ,
"    a <- gsub(\"([0-9])([0-9])([a-zA-Z])\", \"\\\" \\\"^\\\\1\\\\2*\\\\3\", " ,
"        a)" ,
"    a <- gsub(\"([0-9])([a-zA-Z])\", \"\\\" \\\"^\\\\1*\\\\2\", a)" ,
"    a <- gsub(\"([]])(*~~)\", \"\\\\1*{  }*\", a)" ,
"    if (substr(a, nchar(a), nchar(a)) == \"*\") {" ,
"        a <- paste(a, \"symbol(\\\"\\\\052\\\")\", sep = \"\")" ,
"    }" ,
"    left <- length(unlist(strsplit(paste(\" \", a), \"\\\\[\"))) - " ,
"        1" ,
"    right <- length(unlist(strsplit(paste(a, \" \"), \"\\\\]\"))) - " ,
"        1" ,
"    if (left > right) {" ,
"        if (substr(a, nchar(a), nchar(a)) == \"*\") {" ,
"            a <- substr(a, 1, nchar(a) - 1)" ,
"            a <- paste(a, \"]*symbol(\\\"\\\\052\\\")\", sep = \"\")" ,
"        }" ,
"        else {" ,
"            a <- paste(a, \"]\", sep = \"\")" ,
"        }" ,
"    }" ,
"    a <- gsub(\"([*][~]{1,}$)\", \"\", a)" ,
"    a <- gsub(\"Eu/Eu[*],\", \"Eu/Eu,\", a)" ,
"    a <- gsub(\"Eu/Eu[*]\", \"Eu/Eu[*]\", a)" ,
"    a <- gsub(\"(Fe2O3)([t])\", \"Fe[2]*O[3]*\\\\2\", a)" ,
"    options(show.error.messages = FALSE)" ,
"    out <- try(parse(text = as.expression(a)))" ,
"    if (class(out[1]) == \"try-error\") " ,
"        stop(\" \", call. = FALSE)" ,
"    return(out)" ,
"}" ,
"",
"# updated function about()",
"about<-","function () " ,
"{" ,
"    img <<- tclVar()" ,
"    tkimage.create(\"photo\", img, file = paste(gcdx.dir, \"logo.gif\", " ,
"        sep = \"/\"))" ,
"    tt <<- tktoplevel()" ,
"    tkconfigure(tt, padx = 20, pady = 20, width = 100)" ,
"    tkconfigure(tt, cursor = \"left_ptr\")" ,
"    tit <- paste(\"About\", package.name)" ,
"    tkwm.title(tt, tit)" ,
"    tkfocus(tt)" ,
"    txt.frame <- tkframe(tt, borderwidth = 0)" ,
"    logo.fig <- tklabel(txt.frame, image = img)" ,
"    tkgrid(logo.fig, sticky = \"nw\")" ,
"    name <- as.character(packageDescription(package.name, fields = \"Package\"))" ,
"    version <- \"6.2.0 patch 240226\"" ,
"    codename <- readLines(paste(gcdx.dir, \"CODENAME\", sep = \"/\"))" ,
"    built <- as.character(packageDescription(package.name, fields = \"Built\"))" ,
"    date <- as.Date(strsplit(built, \";\")[[1]][3])" ,
"    date <- format(date, \"%d %B %Y\")" ,
"    ver <- paste(name, \" \", version, \"\\n[\", codename, \", \", as.character(date), " ,
"        \"]\\n(c) 1999-\", format(Sys.time(), \"%Y\"), \"\\n\", sep = \"\")" ,
"    Rver <- paste(\"R for\", .Platform$OS.type, paste(getRversion(), " ,
"        collapse = \".\"), sep = \" \")" ,
"    authors <- paste(\"\\n\\nV. Janousek\\nCzech Geological Survey, \\nKlarov 3, 118 21 Prague 1\\nvojtech.janousek@geology.cz\\n        \\nJ.-F. Moyen\\nUniversite St-Etienne, France\\n        \\nV. Erban\\nex-Czech Geological Survey\\n        \\nC. Farrow\\nex-University of Glasgow, Scotland\\n        \", " ,
"        sep = \"\")" ,
"    message <- paste(ver, Rver, authors, sep = \"\")" ,
"    txt <- paste(message, collapse = \"\\n\")" ,
"    info <- tklabel(txt.frame, text = txt, wraplength = 300, " ,
"        justify = \"left\")" ,
"    tkgrid(info, row = 0, column = 1)" ,
"    tkgrid(txt.frame)" ,
"    OnOk <- function() {" ,
"        tkgrab.release(tt)" ,
"        tkdestroy(tt)" ,
"    }" ,
"    frame.but <- tkframe(tt)" ,
"    tkconfigure(frame.but, pady = 10)" ,
"    Ok.but <- tkbutton(frame.but, text = \"  Dismiss   \", command = OnOk, " ,
"        fg = \"darkgreen\")" ,
"    tkgrid(Ok.but, sticky = \"e\", row = 1, column = 1)" ,
"    tkgrid(frame.but, sticky = \"e\")" ,
"    tkfocus(tt)" ,
"    tkwait.window(tt)" ,
"    invisible(FALSE)" ,
"}" ,
"    ns<-asNamespace(\"GCDkit\")" ,
"    unlockBinding(\"r2clipboard\",ns)" ,
"    assign(\"r2clipboard\",eval(parse(text=\"r2clipboard\")),envir=ns,inherits=TRUE)" ,
"    unlockBinding(\"saveResults\",ns)" ,
"    assign(\"saveResults\",eval(parse(text=\"saveResults\")),envir=ns,inherits=TRUE)" ,
"    unlockBinding(\"sampleDataset\",ns)" ,
"    assign(\"sampleDataset\",eval(parse(text=\"sampleDataset\")),envir=ns,inherits=TRUE)" ,
"    unlockBinding(\".annotate.main\",ns)" ,
"    assign(\".annotate.main\",eval(parse(text=\".annotate.main\")),envir=ns,inherits=TRUE)" ,
"#end")
patchName<-paste(gcdx.dir,"/Patch/patch",patchID,".r",sep="")
cat(patch,file=patchName,sep="\n")
source(patchName)
}
